diff --git a/drivers/crypto/aesni_gcm/aesni_gcm_pmd.c b/drivers/crypto/aesni_gcm/aesni_gcm_pmd.c
index e1d5e37..c93ebfe 100644
--- a/drivers/crypto/aesni_gcm/aesni_gcm_pmd.c
+++ b/drivers/crypto/aesni_gcm/aesni_gcm_pmd.c
@@ -517,9 +517,9 @@ aesni_gcm_uninit(const char *name)
 static struct rte_vdev_driver aesni_gcm_pmd_drv = {
 	.driver = {
 		.type = PMD_VDEV,
-		.init = aesni_gcm_init,
-		.uninit = aesni_gcm_uninit
 	},
+	.init = aesni_gcm_init,
+	.uninit = aesni_gcm_uninit
 };
 
 DRIVER_REGISTER_VDEV(CRYPTODEV_NAME_AESNI_GCM_PMD, aesni_gcm_pmd_drv);
diff --git a/drivers/crypto/aesni_mb/rte_aesni_mb_pmd.c b/drivers/crypto/aesni_mb/rte_aesni_mb_pmd.c
index 2ba5389..30c0706 100644
--- a/drivers/crypto/aesni_mb/rte_aesni_mb_pmd.c
+++ b/drivers/crypto/aesni_mb/rte_aesni_mb_pmd.c
@@ -717,9 +717,9 @@ cryptodev_aesni_mb_uninit(const char *name)
 static struct rte_vdev_driver cryptodev_aesni_mb_pmd_drv = {
 	.driver = {
 		.type = PMD_VDEV,
-		.init = cryptodev_aesni_mb_init,
-		.uninit = cryptodev_aesni_mb_uninit
 	},
+	.init = cryptodev_aesni_mb_init,
+	.uninit = cryptodev_aesni_mb_uninit
 };
 
 DRIVER_REGISTER_VDEV(CRYPTODEV_NAME_AESNI_MB_PMD, cryptodev_aesni_mb_pmd_drv);
diff --git a/drivers/crypto/kasumi/rte_kasumi_pmd.c b/drivers/crypto/kasumi/rte_kasumi_pmd.c
index a30e776..ba2829d 100644
--- a/drivers/crypto/kasumi/rte_kasumi_pmd.c
+++ b/drivers/crypto/kasumi/rte_kasumi_pmd.c
@@ -653,9 +653,9 @@ cryptodev_kasumi_uninit(const char *name)
 static struct rte_vdev_driver cryptodev_kasumi_pmd_drv = {
 	.driver = {
 		.type = PMD_VDEV,
-		.init = cryptodev_kasumi_init,
-		.uninit = cryptodev_kasumi_uninit
 	},
+	.init = cryptodev_kasumi_init,
+	.uninit = cryptodev_kasumi_uninit
 };
 
 DRIVER_REGISTER_VDEV(CRYPTODEV_NAME_KASUMI_PMD, cryptodev_kasumi_pmd_drv);
diff --git a/drivers/crypto/null/null_crypto_pmd.c b/drivers/crypto/null/null_crypto_pmd.c
index 8ab34de..4c12faa 100644
--- a/drivers/crypto/null/null_crypto_pmd.c
+++ b/drivers/crypto/null/null_crypto_pmd.c
@@ -271,9 +271,9 @@ cryptodev_null_uninit(const char *name)
 static struct rte_vdev_driver cryptodev_null_pmd_drv = {
 	.driver = {
 		.type = PMD_VDEV,
-		.init = cryptodev_null_init,
-		.uninit = cryptodev_null_uninit
 	},
+	.init = cryptodev_null_init,
+	.uninit = cryptodev_null_uninit
 };
 
 DRIVER_REGISTER_VDEV(CRYPTODEV_NAME_NULL_PMD, cryptodev_null_pmd_drv);
diff --git a/drivers/crypto/snow3g/rte_snow3g_pmd.c b/drivers/crypto/snow3g/rte_snow3g_pmd.c
index 8b356a3..10c6b83 100644
--- a/drivers/crypto/snow3g/rte_snow3g_pmd.c
+++ b/drivers/crypto/snow3g/rte_snow3g_pmd.c
@@ -641,9 +641,9 @@ cryptodev_snow3g_uninit(const char *name)
 static struct rte_vdev_driver cryptodev_snow3g_pmd_drv = {
 	.driver = {
 		.type = PMD_VDEV,
-		.init = cryptodev_snow3g_init,
-		.uninit = cryptodev_snow3g_uninit
 	},
+	.init = cryptodev_snow3g_init,
+	.uninit = cryptodev_snow3g_uninit
 };
 
 DRIVER_REGISTER_VDEV(CRYPTODEV_NAME_SNOW3G_PMD, cryptodev_snow3g_pmd_drv);
diff --git a/drivers/net/af_packet/rte_eth_af_packet.c b/drivers/net/af_packet/rte_eth_af_packet.c
index 95aa573..9a9a2ee 100644
--- a/drivers/net/af_packet/rte_eth_af_packet.c
+++ b/drivers/net/af_packet/rte_eth_af_packet.c
@@ -892,9 +892,9 @@ rte_pmd_af_packet_devuninit(const char *name)
 static struct rte_vdev_driver pmd_af_packet_drv = {
 	.driver = {
 		.type = PMD_VDEV,
-		.init = rte_pmd_af_packet_devinit,
-		.uninit = rte_pmd_af_packet_devuninit
 	},
+	.init = rte_pmd_af_packet_devinit,
+	.uninit = rte_pmd_af_packet_devuninit
 };
 
 DRIVER_REGISTER_VDEV(eth_af_packet, pmd_af_packet_drv);
diff --git a/drivers/net/bonding/rte_eth_bond_pmd.c b/drivers/net/bonding/rte_eth_bond_pmd.c
index 3209dbc..5fa2a93 100644
--- a/drivers/net/bonding/rte_eth_bond_pmd.c
+++ b/drivers/net/bonding/rte_eth_bond_pmd.c
@@ -2511,9 +2511,9 @@ bond_ethdev_configure(struct rte_eth_dev *dev)
 static struct rte_vdev_driver bond_drv = {
 	.driver = {
 		.type = PMD_VDEV,
-		.init = bond_init,
-		.uninit = bond_uninit
 	},
+	.init = bond_init,
+	.uninit = bond_uninit
 };
 
 DRIVER_REGISTER_VDEV(eth_bond, bond_drv);
diff --git a/drivers/net/mpipe/mpipe_tilegx.c b/drivers/net/mpipe/mpipe_tilegx.c
index 6d0dc86..efb000b 100644
--- a/drivers/net/mpipe/mpipe_tilegx.c
+++ b/drivers/net/mpipe/mpipe_tilegx.c
@@ -1626,15 +1626,15 @@ rte_pmd_mpipe_devinit(const char *ifname,
 static struct rte_vdev_driver pmd_mpipe_xgbe_drv = {
 	.driver = {
 		.type = PMD_VDEV,
-		.init = rte_pmd_mpipe_devinit
 	},
+	.init = rte_pmd_mpipe_devinit
 };
 
 static struct rte_vdev_driver pmd_mpipe_gbe_drv = {
 	.driver = {
 		.type = PMD_VDEV,
-		.init = rte_pmd_mpipe_devinit
 	},
+	.init = rte_pmd_mpipe_devinit
 };
 
 DRIVER_REGISTER_VDEV(xgbe, pmd_mpipe_xgbe_drv);
diff --git a/drivers/net/null/rte_eth_null.c b/drivers/net/null/rte_eth_null.c
index 75bad6c..be4169e 100644
--- a/drivers/net/null/rte_eth_null.c
+++ b/drivers/net/null/rte_eth_null.c
@@ -689,9 +689,9 @@ rte_pmd_null_devuninit(const char *name)
 static struct rte_vdev_driver pmd_null_drv = {
 	.driver = {
 		.type = PMD_VDEV,
-		.init = rte_pmd_null_devinit,
-		.uninit = rte_pmd_null_devuninit
 	},
+	.init = rte_pmd_null_devinit,
+	.uninit = rte_pmd_null_devuninit
 };
 
 DRIVER_REGISTER_VDEV(eth_null, pmd_null_drv);
diff --git a/drivers/net/pcap/rte_eth_pcap.c b/drivers/net/pcap/rte_eth_pcap.c
index b72d07e..d6718b8 100644
--- a/drivers/net/pcap/rte_eth_pcap.c
+++ b/drivers/net/pcap/rte_eth_pcap.c
@@ -1086,9 +1086,9 @@ rte_pmd_pcap_devuninit(const char *name)
 static struct rte_vdev_driver pmd_pcap_drv = {
 	.driver = {
 		.type = PMD_VDEV,
-		.init = rte_pmd_pcap_devinit,
-		.uninit = rte_pmd_pcap_devuninit
 	},
+	.init = rte_pmd_pcap_devinit,
+	.uninit = rte_pmd_pcap_devuninit
 };
 
 DRIVER_REGISTER_VDEV(eth_pcap, pmd_pcap_drv);
diff --git a/drivers/net/ring/rte_eth_ring.c b/drivers/net/ring/rte_eth_ring.c
index 67cbee3..77bd664 100644
--- a/drivers/net/ring/rte_eth_ring.c
+++ b/drivers/net/ring/rte_eth_ring.c
@@ -626,9 +626,9 @@ rte_pmd_ring_devuninit(const char *name)
 static struct rte_vdev_driver pmd_ring_drv = {
 	.driver = {
 		.type = PMD_VDEV,
-		.init = rte_pmd_ring_devinit,
-		.uninit = rte_pmd_ring_devuninit
 	},
+	.init = rte_pmd_ring_devinit,
+	.uninit = rte_pmd_ring_devuninit
 };
 
 DRIVER_REGISTER_VDEV(eth_ring, pmd_ring_drv);
diff --git a/drivers/net/vhost/rte_eth_vhost.c b/drivers/net/vhost/rte_eth_vhost.c
index 94577e9..e2610b4 100644
--- a/drivers/net/vhost/rte_eth_vhost.c
+++ b/drivers/net/vhost/rte_eth_vhost.c
@@ -927,9 +927,9 @@ rte_pmd_vhost_devuninit(const char *name)
 static struct rte_vdev_driver pmd_vhost_drv = {
 	.driver = {
 		.type = PMD_VDEV,
-		.init = rte_pmd_vhost_devinit,
-		.uninit = rte_pmd_vhost_devuninit
 	},
+	.init = rte_pmd_vhost_devinit,
+	.uninit = rte_pmd_vhost_devuninit
 };
 
 DRIVER_REGISTER_VDEV(eth_vhost, pmd_vhost_drv);
diff --git a/drivers/net/virtio/virtio_user_ethdev.c b/drivers/net/virtio/virtio_user_ethdev.c
index 08cd4c2..7975298 100644
--- a/drivers/net/virtio/virtio_user_ethdev.c
+++ b/drivers/net/virtio/virtio_user_ethdev.c
@@ -465,9 +465,9 @@ virtio_user_pmd_devuninit(const char *name)
 static struct rte_vdev_driver virtio_user_driver = {
 	.driver = {
 		.type   = PMD_VDEV,
-		.init   = virtio_user_pmd_devinit,
-		.uninit = virtio_user_pmd_devuninit
 	},
+	.init   = virtio_user_pmd_devinit,
+	.uninit = virtio_user_pmd_devuninit
 };
 
 DRIVER_REGISTER_VDEV(virtio_user, virtio_user_driver);
diff --git a/drivers/net/xenvirt/rte_eth_xenvirt.c b/drivers/net/xenvirt/rte_eth_xenvirt.c
index fa00e52..0bbe130 100644
--- a/drivers/net/xenvirt/rte_eth_xenvirt.c
+++ b/drivers/net/xenvirt/rte_eth_xenvirt.c
@@ -762,9 +762,9 @@ rte_pmd_xenvirt_devuninit(const char *name)
 static struct rte_vdev_driver pmd_xenvirt_drv = {
 	.driver = {
 		.type = PMD_VDEV,
-		.init = rte_pmd_xenvirt_devinit,
-		.uninit = rte_pmd_xenvirt_devuninit
 	},
+	.init = rte_pmd_xenvirt_devinit,
+	.uninit = rte_pmd_xenvirt_devuninit
 };
 
 DRIVER_REGISTER_VDEV(eth_xenvirt, pmd_xenvirt_drv);
diff --git a/lib/librte_eal/common/eal_common_vdev.c b/lib/librte_eal/common/eal_common_vdev.c
index e1ca8e0..83f8ea8 100644
--- a/lib/librte_eal/common/eal_common_vdev.c
+++ b/lib/librte_eal/common/eal_common_vdev.c
@@ -73,7 +73,7 @@ rte_eal_vdev_init(const char *name, const char *args)
 		 * So use strncmp to compare.
 		 */
 		if (!strncmp(driver->driver.name, name, strlen(driver->driver.name)))
-			return driver->driver.init(name, args);
+			return driver->init(name, args);
 	}
 
 	RTE_LOG(ERR, EAL, "no driver found for %s\n", name);
@@ -96,7 +96,7 @@ rte_eal_vdev_uninit(const char *name)
 		 * So use strncmp to compare.
 		 */
 		if (!strncmp(driver->driver.name, name, strlen(driver->driver.name)))
-			return driver->driver.uninit(name);
+			return driver->uninit(name);
 	}
 
 	RTE_LOG(ERR, EAL, "no driver found for %s\n", name);
diff --git a/lib/librte_eal/common/include/rte_dev.h b/lib/librte_eal/common/include/rte_dev.h
index a4f08b5..3097194 100644
--- a/lib/librte_eal/common/include/rte_dev.h
+++ b/lib/librte_eal/common/include/rte_dev.h
@@ -105,16 +105,6 @@ rte_pmd_debug_trace(const char *func_name, const char *fmt, ...)
 TAILQ_HEAD(rte_driver_list, rte_driver);
 
 /**
- * Initialization function called for each device driver once.
- */
-typedef int (rte_dev_init_t)(const char *name, const char *args);
-
-/**
- * Uninitilization function called for each device driver once.
- */
-typedef int (rte_dev_uninit_t)(const char *name);
-
-/**
  * Driver type enumeration
  */
 enum pmd_type {
@@ -129,8 +119,6 @@ struct rte_driver {
 	TAILQ_ENTRY(rte_driver) next;  /**< Next in list. */
 	enum pmd_type type;		   /**< PMD Driver type */
 	const char *name;                   /**< Driver name. */
-	rte_dev_init_t *init;              /**< Device init. function. */
-	rte_dev_uninit_t *uninit;          /**< Device uninit. function. */
 };
 
 /**
diff --git a/lib/librte_eal/common/include/rte_vdev.h b/lib/librte_eal/common/include/rte_vdev.h
index 9a2e2d5..70a62c0 100644
--- a/lib/librte_eal/common/include/rte_vdev.h
+++ b/lib/librte_eal/common/include/rte_vdev.h
@@ -44,11 +44,23 @@ extern "C" {
 TAILQ_HEAD(vdev_driver_list, rte_vdev_driver);
 
 /**
+ * Initialization function called for each virtual device driver once.
+ */
+typedef int (rte_vdev_init_t)(const char *name, const char *args);
+
+/**
+ * Uninitilization function called for each virtual device driver once.
+ */
+typedef int (rte_vdev_uninit_t)(const char *name);
+
+/**
  * A virtual device driver abstraction.
  */
 struct rte_vdev_driver {
 	TAILQ_ENTRY(rte_vdev_driver) next; /**< Next in list. */
 	struct rte_driver driver;          /**< Inherited general driver. */
+	rte_vdev_init_t *init;         /**< Virtual device init. function. */
+	rte_vdev_uninit_t *uninit;     /**< Virtual device uninit. function. */
 };
 
 /**